net.i2p.router.tunnel.pool

## Class ExploratoryPeerSelector

- java.lang.Object
- - net.i2p.router.tunnel.pool.ConnectChecker
  - - net.i2p.router.tunnel.pool.TunnelPeerSelector
    - - net.i2p.router.tunnel.pool.ExploratoryPeerSelector

-     class ExploratoryPeerSelector
      extends TunnelPeerSelector

  Pick peers randomly out of the not-failing pool, and put them into a tunnel ordered by XOR distance from a random key.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class net.i2p.router.tunnel.pool.TunnelPeerSelector

      `TunnelPeerSelector.Excluder, TunnelPeerSelector.HopChainValidator`

  - ### Field Summary

    - ### Fields inherited from class net.i2p.router.tunnel.pool.ConnectChecker

      `ANY_V4, ctx, log`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExploratoryPeerSelector(RouterContext context)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<Hash>` | `selectPeers(TunnelPoolSettings settings)` Returns ENDPOINT FIRST, GATEWAY LAST!!!! In: us ..

    - ### Methods inherited from class net.i2p.router.tunnel.pool.TunnelPeerSelector

      `allowAsIBGW, allowAsOBEP, checkTunnel, filterSlow, getClosestHopExclude, getExclude, getLength, getPeerConnectMask, isDuplicateSequence, isIPv6Only, orderPeers, regeneratePeers, selectExplicit, shouldExclude, shouldSelectExplicit`

    - ### Methods inherited from class net.i2p.router.tunnel.pool.ConnectChecker

      `canConnect, canConnect, canConnect, getConnectMask, getInboundMask, getOutboundMask, isNTCPDisabled, isSSUDisabled`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ExploratoryPeerSelector

          public ExploratoryPeerSelector(RouterContext context)

  - ### Method Detail

    - #### selectPeers

          public List<Hash> selectPeers(TunnelPoolSettings settings)

      Returns ENDPOINT FIRST, GATEWAY LAST!!!! In: us .. closest .. middle .. IBGW Out: OBGW .. middle .. closest .. us
      Specified by:
        `selectPeers` in class `TunnelPeerSelector`
      Returns:
        ordered list of Hash objects (one per peer) specifying what order they should appear in a tunnel (ENDPOINT FIRST). This includes the local router in the list. If there are no tunnels or peers to build through, and the settings reject 0 hop tunnels, this will return null.